#include <sys/types.h>
#include <sys/socket.h>
#include <sys/un.h>
#include <stdio.h>
#include <string.h>
#include <strings.h>
#include <stdlib.h>
#include <unistd.h>

#define MAXLINE 256

#define SERVER_SOCKET "./server.socket"
#define CLIENT_SOCKET "./client.socket"

int main(int argc, char **argv)
{
  int sockfd, num_read;
  char buffer[MAXLINE];
  struct sockaddr_un servaddr;
  struct sockaddr_un cliaddr;

  /* creates socket datagram domain internet */
  if ((sockfd = socket(AF_UNIX, SOCK_DGRAM, 0)) < 0){
    perror("socket error");
    exit(-1);
  }
  
  /* client structure address cleaning */
  bzero(&cliaddr, sizeof(cliaddr));
  cliaddr.sun_family = AF_UNIX;
  strcpy(cliaddr.sun_path, CLIENT_SOCKET);

  /* binds socket to address */
  if (bind(sockfd, (struct sockaddr *) &cliaddr, sizeof(cliaddr)) < 0){
     perror("client, can't bind to address");
     exit(-1);
  }

  /* server structure address cleaning */
  bzero(&servaddr, sizeof(servaddr));
  servaddr.sun_family = AF_UNIX;
  strcpy(servaddr.sun_path, SERVER_SOCKET);

  /* reads from stdin */
  num_read = read(0,buffer,MAXLINE);
  if (num_read <= 0) {
    perror("client, error reading from stdin.");
    exit(-1);
  }
  buffer[num_read-1] = '\0';

  /* writes to socket */
  sendto(sockfd, buffer, num_read, 0, (struct sockaddr *)&servaddr, 
    sizeof(servaddr));
  
  /* waits for an answer */
  num_read = recvfrom(sockfd, buffer, MAXLINE, 0, NULL, NULL);
  if (num_read > 0) {
    printf("answer: %s\n", buffer);
  }
  
  close(sockfd);
  unlink(cliaddr.sun_path);

  exit(0);
}
