#include <sys/types.h>
#include <sys/socket.h>
#include <sys/un.h>
#include <stdio.h>
#include <time.h>
#include <string.h>
#include <strings.h>
#include <unistd.h>
#include <stdlib.h>

#define MAXLINE 256

#define SOCKET "./server.socket"

int main(int argc, char **argv)
{
  int sockfd, num_read;
  struct sockaddr_un servaddr, cliaddr;
  socklen_t clilen;
  char buffer[MAXLINE];
 
  /* creates socket datagram domain unix */
  if ((sockfd = socket(AF_UNIX, SOCK_DGRAM, 0)) < 0){
    perror("server: can't open datagram socket");
    exit(-1);
  }

  /* structure address cleaning */
  bzero(&servaddr, sizeof(servaddr));
  servaddr.sun_family = AF_UNIX;
  strcpy(servaddr.sun_path, SOCKET);

  /* if exists, deletes socket file name */
  unlink(servaddr.sun_path);
  
  /* binds socket to address */
  if (bind(sockfd, (struct sockaddr *) &servaddr, sizeof(servaddr)) < 0){
    perror("server, can't bind to address");
    exit(-1);
  }

  while(1) {

    /* read string from client */
    clilen = sizeof(cliaddr);
    num_read = recvfrom(sockfd, buffer, MAXLINE, 0, 
      (struct sockaddr *)&cliaddr, &clilen);
    if (num_read > 0) {
      
      /* echo string to client */
      sendto(sockfd, buffer, num_read, 0, (struct sockaddr *)&cliaddr, clilen);
    }
  }
}
